// overview.c

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object *ob;
	int i, m;

	switch(arg) {
		case "user":
			ob = users();
			printf("@ %d ӨϥΪ̪C\n", sizeof(ob));
			break;
		case "living":
			ob = livings();
			printf("@ %d ӥͪ(tϥΪ)C\n", sizeof(ob));
			break;
		case "char":
			ob = objects( (: $1->is_character() && !clonep($1) :) );
			printf("@ %d ؤH master copy QJC\n", sizeof(ob));
			break;
		case "npc":
			ob = filter_array( livings(),
				(: $1->is_character() && !userp($1) && clonep($1) :) );
			printf("@ %d  NPC C\n", sizeof(ob));
			break;
		case "combat":
			ob = objects( (: $1->is_fighting() :) );
			printf("@ %d ӤHb԰AC\n", sizeof(ob));
			break;
		case "kill":
			ob = objects( (: $1->is_killing() && $1->is_fighting() :) );
			printf("@ %d ӤHbʩR۷i԰AC\n", sizeof(ob));
			break;
		case "hunt":
			ob = objects( (: $1->is_killing() :) );
			printf("@ %d ӤHMLHۤC\n", sizeof(ob));
			break;
		case "heart beat":
			ob = objects( (: query_heart_beat :) );
			printf("@ %d Ӫ heart beat ĪAC\n", sizeof(ob));
			break;
		case "virtual":
			ob = objects( (: virtualp :) );
			printf("@ %d ӵC\n", sizeof(ob));
			break;
		case "room":
			ob = objects( (: function_exists("create_door", $1) :) );
			printf("@ %d өжC\n", sizeof(ob));
			break;
		case "special room":
			// inherits won't work if master copy got cleaned up.
			if( !find_object(ROOM) ) ROOM->foo();
			ob = objects( (: inherits(ROOM, $1) :) );
			printf("@ %d Ӫ~ӼзǩжC\n", sizeof(ob));
			break;
		case "equip":
			// inherits won't work if master copy got cleaned up.
			if( !find_object(F_EQUIP) ) F_EQUIP->foo();
			ob = objects( (: inherits(F_EQUIP, $1) :) );
			printf("@ %d Ӫ~ӼзǸ˳ơC\n", sizeof(ob));
			break;
		case "object":
			ob = objects();
			printf("@ %d ӪQJC\n", sizeof(ob));
			break;
		default:
			return notify_fail("O榡Roverview <topic>\n");
	}
	m = 0;
	i = sizeof(ob);
	while(i--)
		m += memory_info(ob[i]);
	printf("`@ϥ %d bytes OC\n", m);
	if( sizeof(ob) )
		printf("CӪϥ %d bytes OC\n", m / sizeof(ob));
	return 1;
}

int help()
{
	write(@TEXT
O榡Roverview <DD>

user:		userp()
living:		living()
room:		function_exists("create_door", ob);
TEXT
	);
	return 1;
}


