/*  edemote.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <command.h>

inherit F_CLEAN_UP;

int in_use;

int main(object me, string arg)
{
    mapping emote;

    SECURED_COMMAND;

    if( !arg ) return notify_fail("Ans褰 emoteS\n");

    if( sscanf(arg, "-d %s", arg) ) {
        write("R emoteR" + arg + "\n");
        EMOTE_D->delete_emote(arg);
        return 1;
    }

    if( sscanf(arg, "-p %s", arg) ) {
        emote = EMOTE_D->query_emote(arg);
        printf("WקR%s\n", emote["updated"]);
        printf("wwwwwwwwwwwww\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
            emote["myself"], emote["others"], emote["myself_self"],
            emote["others_self"], emote["myself_target"], emote["target"],
            emote["others_target"] );
        return 1;
    }

    emote = EMOTE_D->query_emote(arg);
    emote = (["updated":geteuid(me)]);

    write("s emoteR" + arg + "\n");
    write("TiHnXM . ܵC\n");
    write("TiϥΪѼƦHUXءR\n");
    write("  $N  ۤvWrC\n");
    write("  $n  ϥιHWrC\n");
    write("  $P  ۤvH٥NWMpABpBLBoBeBC\n");
    write("  $p  ϥιHH٥NWMpABpBLBoBeBC\n");
    write("wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n");
    write("wHϥγo emote ɡMAۤvݨ쪺TR\n->");
    input_to("get_msg_myself", emote, arg);
    return 1;
}


private int
get_msg_myself(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["myself"]) ) emote["myself"] += "\n";
        write("wHϥγo emote ɡMLHݨ쪺TR\n->");
        input_to("get_msg_others", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["myself"]) )
        emote["myself"] += msg + "\n";
    else emote["myself"] = msg;
    write("->");
    input_to("get_msg_myself", emote, pattern);
    return 1;
}

private int
get_msg_others(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["others"]) ) emote["others"] += "\n";
        write("ۤvϥγo emote ɡMۤvݨ쪺TR\n->");
        input_to("get_msg_myself_self", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["others"]) )
        emote["others"] += msg + "\n";
    else emote["others"] = msg;
    write("->");
    input_to("get_msg_others", emote, pattern);
    return 1;
}

private int
get_msg_myself_self(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["myself_self"]) ) emote["myself_self"] += "\n";
        write("ۤvϥγo emote ɡMLHݨ쪺TR\n->");
        input_to("get_msg_others_self", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["myself_self"]) )
        emote["myself_self"] += msg + "\n";
    else emote["myself_self"] = msg;
    write("->");
    input_to("get_msg_myself_self", emote, pattern);
    return 1;
}

private int
get_msg_others_self(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["others_self"]) ) emote["others_self"] += "\n";
        write("OHϥγo emote ɡMۤvݨ쪺TR\n->");
        input_to("get_msg_myself_target", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["others_self"]) )
        emote["others_self"] += msg + "\n";
    else emote["others_self"] = msg;
    write("->");
    input_to("get_msg_others_self", emote, pattern);
    return 1;
}

private int
get_msg_myself_target(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["myself_target"]) ) emote["myself_target"] += "\n";
        write("OHϥγo emote ɡMϥιHݨ쪺TR\n->");
        input_to("get_msg_target", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["myself_target"]) )
        emote["myself_target"] += msg + "\n";
    else emote["myself_target"] = msg;
    write("->");
    input_to("get_msg_myself_target", emote, pattern);
    return 1;
}

private int
get_msg_target(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["target"]) ) emote["target"] += "\n";
        write("OHϥγo emote ɡMAۤvMϥιH~MLHݨ쪺TR\n->");
        input_to("get_msg_others_target", emote, pattern);
        return 1;
    }
    if( !undefinedp(emote["target"]) )
        emote["target"] += msg + "\n";
    else emote["target"] = msg;
    write("->");
    input_to("get_msg_target", emote, pattern);
    return 1;
}

private int
get_msg_others_target(string msg, mapping emote, string pattern)
{
    if (msg==".") {
        if( !undefinedp(emote["others_target"]) ) emote["others_target"] += "\n";
        EMOTE_D->set_emote(pattern, emote);
        write("Emote s赲C\n");
        return 1;
    }
    if( !undefinedp(emote["others_target"]) )
        emote["others_target"] += msg + "\n";
    else emote["others_target"] = msg;
    write("->");
    input_to("get_msg_others_target", emote, pattern);
    return 1;
}

int help(object me)
{
    write(@HELP
O榡Gedemote [-d|-p] <emote>
 
oӫOiHק, R emote ΦCX䤺e. [W -d ѼƷ|R
w emote, -p Ѽƫh|CXw emote e. CXǻPs
 emote ɬۦP.
 
J emote TɦTӶ: Sؼ, wؼЩάOۤv. Y
QYT, hbťզJ '.' L.
 
@ emote TiHܦh, bťզJ '.' JӶ emote.
 
s emote ɥiHΥHUŸӪ:
 
$N : ۤvWr.
$n : ؼЪWr.
$P : ۤvH٥NW.
$p : ؼЪH٥NW.
 
HELP
    );
    return 1;
}
