/*  cast - the spell-casting command

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <skill.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
    string spells, spl, trg;
    object target;
        
    if( me->query("life_form") == "ghost" )
        return notify_fail("HFN@FʤF, ֥h䫰_a!!\n");

    if( me->is_busy() ) return notify_fail("A{bSšI\n");

    if( !arg ) return notify_fail("O榡Rcast <GW> [on <IGH>]\n");

    if( sscanf(arg, "%s on %s", spl, trg)==2 ) {
	target = present(trg, environment(me));
	if( !target ) target = present(trg, me);
	if( !target ) return notify_fail("ǫS " + trg + "C\n");

	// add by dragoon, modified by annihilator
	if( userp(target) && !interactive(target) ) {
	     write("A_uHIkC\n");
	     return 1;
	}
    } else {
	spl = arg;
	target = 0;
    }

    if( environment(me)->query("no_magic")
    && !me->is_fighting(target)
    && !target->query("unprotect_mark") ) {
	    tell_object(me, "o̤԰C\n");
	    return 1;
    }

    spl = replace_string( spl, " ", "_");

    notify_fail("AХ enable OܧAnϥΪGtC\n");
    if( stringp(spells = me->skill_mapped("spells")) )
	return (int)SKILL_D(spells)->cast_spell(me, spl, target);

    return 0;
}

int help (object me)
{
    write(@HELP
O榡Rcast <GW> [on <IGH>]

IikNAAݭnw<GW>A<IGH>YwBԪAhiٲC

bAϥάY@өG大eAA enable OӫwAnϥΪGtA
ϥΪөGtGAGW٥iѦ help taoismC

jhƪkNqA}luwGA짹kN|ݭn@qɶCoqɶIk̷|
LkʩΧC
HELP
    );
    return 1;
}
