/*  cestablish.c - to establish a clan

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/
#include <login.h>
#include <ansi.h>
inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object who;

	if( !arg ) {
		if( me->query("level") < 50 
		|| me->query_score("reputation") < 60000 ) return 
			notify_fail("unŪa~C\n");

		if( me->query("clan/create") ) return 
			notify_fail("CӤH@ͥu\\гy@sC\n");

		if( me->query("clan/clan_level") ) return 
			notify_fail("AwgOF, ХC\n");

		if( me->query_temp("clan/sign_number") < 2 ) return
			notify_fail("AܤֱoӰƤ~C\n");
		write("ثewpU: \n\n");
		seteuid(ROOT_UID);
		write( read_file("/obj/CLAN") );
		write("\nbWMwe, iHɥHO:qC\n");
		write("Ф@㭷檺sCпJW: ");
		input_to("get_clan_name", me);
		return 1;
	}

	if( sscanf(arg, "with %s", arg) ) {
		if( me->query("level") < 44 ) return 
			notify_fail("AŤHѻPC\n");

		if( me->query("clan/clan_level") ) return 
			notify_fail("AwgOF, LkU~HC\n");

		if( me->query("clan/signed") ) return 
			notify_fail("Awg߹L|FC\n");

		who = present(arg, environment(me));

		if( who == me ) return notify_fail("ЧۤvH~HC\n");

		if( !objectp(who) || !living(who) ) 
			return notify_fail("ǫSoӤHC\n");

		message_vision(HIW"$NMwU$nХߤ@ӷsC\n"NOR
		, me, who);

		who->add_temp("clan/sign_number", 1);
		me->set("clan/signed", 1);
#ifdef SAVE_USER
        me->save();
#endif
		return 1; }
	else {
		tell_object(me, 
		"O榡: cestablish άO cestablish with <YH>\n");
		return 1;
	}
}

private void get_clan_name(string arg, object me)
{
        seteuid(getuid(me));
	me->set("clan/clan_name", arg);
	write("zTwnγozW(y/n/q)S");
	input_to("confirm_name", me);
}

private void confirm_name(string yn, object me)
{        
	if( yn=="" ) {
		write("zTwnγozW(y/n)S");
                input_to("confirm_name", me);
                return;
	}
	if( yn == "q" ) {
		write("....UaC\n");
		return;
	}

        if( yn[0]!='y' && yn[0]!='Y' ) {
                write("ЭsJzQnWr: ");
                input_to("get_clan_name", me);
                return;
        }
	seteuid(ROOT_UID);
	// keep in /log/CLAN
	log_file("CLAN", sprintf("[%s] %s  %s(%s) Х\n",
        ctime(time()), me->query("clan/clan_name"), me->name(),
        me->query("id")) );
	// write in /obj/CLAN for player to query clan data
	write_file("/obj/CLAN", sprintf("[%s] %s  %s(%s) Х\n",
	ctime(time()), me->query("clan/clan_name"), me->name(),
	me->query("id")) );
	write("пJoɤHٸ(p: D, D, x): ");
	input_to("get_clan_rank", me);
}

private void get_clan_rank(string arg, object me)
{
	if( strlen(arg) > 4 ) {
		write("ٸL, ЭsJ: ");
		input_to("get_clan_rank", me);
	}
	seteuid(getuid(me));
	me->set("clan/rank", arg);
	me->set("clan/nick", "Ĥ@NjY");
	me->set("clan/clan_level", 3);
	me->set("clan/elder", 0);
	write("zTwnγozٸ(y/n)S");
	input_to("confirm_rank", me);
}

private void confirm_rank(string yn, object me)
{
	object mark;

	if( yn=="" ) {
		write("zTwnγozٸ(y/n)S");
                input_to("confirm_rank", me);
                return;
        }

        if( yn[0]!='y' && yn[0]!='Y' ) {
                write("ЭsJzQnٸ: ");
                input_to("get_clan_rank", me);
                return;
        }
#ifdef SAVE_USER
        me->save();
#endif
	message("system", HIW"Ѵ¤i: "+me->query("clan/clan_name")
	+"w"+me->name()+"Хߧ, }lۦ!!\n"NOR, users());
	mark = new("/obj/clan_symbol");
	mark->move(me);
	return;		
}


int help(object me)
{
write(@HELP
Oγ~, QH(HUHD٤)
H(HUH٤)U@_i, ন߷sCb
, HƥݦbHHW, ӦUаѾ\
: help clan, O榡pU:
1. 
   cestablish with <YH>
2. D
   cestablish
   HܶJU򥻸ơC>
HELP
    );
    return 1;
}
