/*  exert.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

inherit F_CLEAN_UP;

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    int ratio;
    string f, dest;
    object target;

    if( !(f = me->skill_mapped("force")) )
        return notify_fail("A{bèSϥΥ󤺥\\C\n");
    if( f=="force" )
        return notify_fail("A enable @ؤ\\C\n");

    if( !arg ) {
        ratio = me->query("force_ratio");
        if( !ratio ) ratio = 75;
        printf("Ab@ԮɱNϥX%s%s\\OC\n",
            chinese_number(ratio/10), (ratio%10==0 ? "" : chinese_number(ratio%10)));
        return 1;
    }

    if( sscanf(arg, "%d", ratio)==1 ) {
        if( ratio < 10 || ratio > 100 )
            return notify_fail("A౱dOb@Q\\OC\n");
        me->set("force_ratio", ratio);
        write("Ok.\n");
        return 1;
    }

    if( me->is_busy() )
        return notify_fail("A halt AbơT\n");

    if( sscanf(arg, "%s on %s", arg, dest)==2 ) {
        target = present(dest, environment(me));
//        if( !target || !target->is_target() )
//            return notify_fail("ǫSoӤHC\n");
// edit by ueiren .....cant find is_target()
	if( !target ) target = present( dest, me );
	if( !target ) return notify_fail("ǫSoӤHC\n");
    }
    notify_fail("AҨϥΪ\\Soإ\\C\n");
    return SKILL_D(me->skill_mapped("force"))->exert_function(me, arg, target);
}

int help(object me)
{
    write(@TEXT
O榡Rexert [<\> [on <ؼ>]]
          exert <\Oʤ(10-100)>
          exert

ϥΤ\Yǥ\Mγ]wb԰nϥXX\OMexert 100 ܧANϥXO
԰MAޯणɭԧA\ONবoۦpMϥXO԰NϧA
BΤ\@԰ɪRvB}aOBPmOMO۹諸O𪺮Ӥ]۷
jMzĤHɧAiHܨϥΤB\OH`OC

[ѼƮɷ|ܧA{b]wC

ϥΤ\ޯɩҥΪ\HAǲߪ\ӲMq`AiH exert <\W> 
׷Ҥ\MLǯS\׷Ҥki|PC

TEXT
    );
    return 1;
}
