/*  fight.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <ansi.h>
#include <char.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
    object obj, old_target;
    int rg, rk, rgm, rkm;

    if( me->query("life_form")=="ghost" )
        return notify_fail("HFN@FʤF, ֥h䫰_a!!\n");

    if( environment(me)->query("no_fight") )
	return notify_fail("o̸T԰C\n");
 
    if( !arg
    ||	!objectp(obj = present(arg, environment(me)))
    ||	!obj->is_character()
    ||	obj->is_corpse() )
	return notify_fail("AQ֡S\n");

    if( obj->query("no_fight") ) return notify_fail("C\n");

    // iw_ua -Dragoon
    if( userp(obj) && !interactive(obj) ) 
        return notify_fail("oH{bbuWC\n");

    if( !me->visible(obj) )
	return notify_fail( obj->name() + "ݤAADAbVLDԡC\n");

    if( me->is_apprentice_of(obj) )
	return notify_fail( obj->name() + "OAvT\n");

    if( obj->is_fighting(me) )
	return notify_fail("[oT[oT[oT\n");

    if( !living(obj) && inherits(F_ATTACK, obj) )
	return notify_fail( "M" + obj->name() + "԰H\n"); 

    if( obj==me ) return notify_fail("AۤvC\n");

    if( userp(obj) && (object)obj->query_temp("pending/fight")!=me ) {
	message_vision("\n$N$nDR" 
	    + me->rank("self") + me->name() + "Aгo"
	    + obj->rank("respectful") + "ۡT\n\n", me, obj);

	if( objectp(old_target = me->query_temp("pending/fight"))
	&&  obj != old_target
	&&  environment(old_target)==environment(me) )
	    message_vision("\n$NV$nꮱADG"
		+ me->rank("self") + "AбСC\n", me, old_target);
	me->set_temp("pending/fight", obj);

	tell_object(obj, YEL "pGA@NMiաAЧA]" + me->name() + "("+(string)me->query("id")+")"+ "U@ fight OC\n" NOR);
	write(YEL "ѩOѪaHAAPN~iաC\n" NOR);
	return 1;
    }

    if( obj->query("civilized") ) {
	if( me->is_fighting() )
	    message_vision( "\n$N$nDG@ֻгo"
		+ obj->rank("respectful") + "ۡT\n\n", me, obj);
	else
	    message_vision( "\n$N$nDR" 
		+ me->rank("self") + me->name() + "Aгo"
		+ obj->rank("respectful") + "ۡT\n\n", me, obj);

	if( obj->query_temp("pending/fight")==me ) {
	    obj->start_busy(1);
//	delete else, 賣busyӫDUfightOHbusy only -dragoon
//	else 
	    me->start_busy(1);
	}

	if( !userp(obj) && !obj->accept_fight(me) ) {
	    write("ݰ_" + obj->name() + "äQAqC\n");
	    return 1;
	}

	me->fight_ob(obj);
	obj->fight_ob(me);
    } else {
	message_vision("\n$Njܤ@nA}l$noʧT\n\n", me, obj);
	me->fight_ob(obj);
	obj->kill_ob(me);
    }

    return 1;
}

int help(object me)
{
    write(@HELP
O榡 : fight <H>
 
oӫOAV@ӤHuQСvΪ̬OuRZvMoاΦ԰ºO
I쬰M]u|OM|uˡMOäOҦ  NPC w
[M]\\hpAZnD|QڵC
 
LO: kill

PS. pG褣@NADԡMAMiHw kill O}l԰M
     fight  kill ϤЬ 'help combat'.
HELP
    );
    return 1;
}
 
