/*  halt.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include "/doc/help.h"
#include <action.h>
#include <command.h>

inherit F_CLEAN_UP;

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    SECURED_COMMAND;

    if( me->is_busy() ) {
        me->interrupt(me, INTR_HALT);
        if( ! me->is_busy() ) {
            write("OkC\n");
            return 1;
        }
        return 0;
    }

    if( !me->is_fighting() )
        return notify_fail("A{bèSb԰C\n");

    if( wizardp(me) ) {
        me->remove_all_killer();
        message_vision("$NΧŮvOFoC\n", me);
    } else {
        me->remove_all_enemy();
        message_vision("$NV@DA}԰}⤣FC\n", me);
    }

    write("Ok.\n");
    return 1;
}

int help(object me)
{
   write(@HELP
O榡Ghalt

iHҦPA(p)bi檺աMObAʩR۷iĤHq`
|MC

oӫOɭԤ]iHΨӰ@ǻݭnɶʧ@Ap׽m\B
ALणఱnӰʧ@өwC
HELP
   );
   return 1;
}
