// open.c

#include <room.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	mapping doors;
	string *dirs, dir, key;
	object key_ob;
	int i;

	if( !arg ) return notify_fail("AnWFH\n");
	if( sscanf(arg, "%s with %s", arg, key) != 2 )
		return notify_fail("AnΤFWH\n");
	if( !objectp(key_ob = present(key, me)) )
		return notify_fail("AWSoتFC\n");


	doors = environment(me)->query_doors();
	if( mapp(doors) ) {
		dirs = keys(doors);
		if( member_array(arg, dirs)!=-1 ) dir = arg;
		else for(i=0; i<sizeof(dirs); i++)
			if( arg==doors[dirs[i]]["name"] || member_array(arg, doors[dirs[i]]["id"])!=-1 ) {
				dir = dirs[i];
				break;
			}
		if( !dir ) return notify_fail("AnWFS\n");
	
		if( environment(me)->lock_door(dir, key_ob->query("lock")) ) {
			message_vision("$NN" + doors[dir]["name"] + "WC\n", me);
			return 1;
		}
	}

	return 0;
}

int help(object me)
{
        write(@HELP
O榡 : lock <~Ϊ> with <_..>
 
oӫOiHAWYǪήeC
 
HELP
    );
    return 1;
}
