/*  keep.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

inherit F_CLEAN_UP;

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    object ob, *all_ob;
    int i;

    if( !arg ) return notify_fail("O榡Gkeep <W~>\n");
    if( arg=="all" ) {
        all_ob = all_inventory(me);
        i = sizeof(all_ob);
        while( i-- )
            all_ob[i]->set("keep_this", 1);
        write("ANҦWFOFӤpOC\n");
        return 1;
    }
    if( arg=="none" ) {
        all_ob = all_inventory(me);
        i = sizeof(all_ob);
        while( i-- )
            all_ob[i]->set("keep_this", 0);
        write("ANҦWF褧pOMC\n");
        return 1;
    }
    ob = present(arg, me);
    if( !ob ) return notify_fail("AWSo˪FC\n");
    if( userp(ob) ) return notify_fail("C\n");
    if( ob->query("keep_this") ) {
        ob->delete("keep_this");
        write("A " + ob->name() + " WpOMFC\n");
    }
    else {
        ob->set("keep_this", 1);
        write("Ab " + ob->name() + " WFӤpOC\n");
    }
    return 1;
}

int help(object me)
{
    write(@HELP
O榡Gkeep <W~>|<all>|<none>

Ҧp:
keep none    NҦ~Ѱ keep
keep sword    w sword ]w keep θѰ keep

]wWn~|Qpߥ(p drop all  sell all)AiH inventory
OdݬO_w]w keep C

]wHN󪺪FuAw/XoӪFɤ~|QνXAåB
]w|QѰCYAN]wHN󪺪~aWAA߰_ӥs]w@C
HELP
    );
    return 1;
}
