/*  option.h

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <command.h>

inherit F_CLEAN_UP;

private void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    string term;
    mixed v;

    if( !arg )
    {
        mapping opt = me->query("option");
        string str = "A]wﶵF\n";

        if( !mapp(opt) || !sizeof(opt) )
            str += "    LC\n";
        else
            foreach(term, v in opt)
                str += sprintf("    %-20sG%O\n", term, v);
        write(str);
        return 1;
    }

    if( sscanf(arg, "%s %d", term, v)==2
    ||	sscanf(arg, "%s %s", term, v)==2 ) {
	if( !v ) me->delete("option/" + term);
	else me->set("option/" + term, v);
    } else
	return notify_fail("O榡Goption <ﶵ> <]w>\n");

    write("Ok.\n");
    return 1;
}

int help()
{
    write(@TEXT
O榡Goption <ﶵ> <]w>

oӫOA]w@ǦϥΪ̤ﶵC

BRIEF_ROOM
  0 - ʮ[жԲӱԭzC(w])
  1 - ʮɤܩжԲӱԭzC

BRIEF_SHORT
  0 - ܪ~ΤHP^W١C(w])
  1 - uܪ~ΤHW١C
TEXT
    );
    return 1;
}
