// syndicator.c

#include <ansi.h>
#include <weapon.h>

inherit F_DAGGER;
inherit F_UNIQUE;

void create()
{
	set_name("uخQv", ({ "syndicator" }));
	set_weight(3000);
    setup_dagger(3, 14, 100, 5);

	if( !clonep() ) {
		set("wield_as", ({ "dagger", "secondhand dagger" }));
		set("unit", "");
		set("value", 32000);
		set("rigidity", 40);
		set("long",
			"oO@|oPMbWκӪJuťX@Ӭ\n"
			"klyM_SOoklOXYbQL䪺\n"
			"MP`_uMuΨⰦC\n");
	}
	setup();
}

int inflict_damage(string strength, object victim)
{
	int dam = ::inflict_damage(strength, victim);

    if( dam && random(100) < 40 ) {
		environment()->add_temp("fight_msg", HIW "خQMoX@}檺nA" NOR);
        victim->act(15);
	}
	return dam;
}
