// fighter.c

#include <attack.h>
#include <statistic.h>

// prototypes
mixed do_chat(mixed chat);
varargs string name(int raw);
void kill_ob(object ob);
varargs int is_fighting(object ob);
int query_level();
string rank(string politeness);

int accept_fight(object ob)
{
    if( is_fighting() ) {
        int differ;

        differ = query_level() - (int)ob->query_level();
        if( differ > 10 ) {
            do_chat( name() + "ۻDRKK ... ӤFܡS\n");
            return 1;
        } else if( differ > 5 ) {
            do_chat( name() + "DRKK ... " + rank("self") + "ѭnӭӥHT\n");
            return 1;
        } else {
            do_chat( name() + "DRo" + ob->rank("respectful") + "DOQʦhӡS\n");
            return 0;
        }
    }

    if( ob->is_fighting() ) {
	do_chat( name() + "DGRZA٬O楴WnAڥb@Ǳ}aC\n");
	return 0;
    }

    if( query_stat_current("kee") < query_stat_maximum("kee") ) {
	do_chat( name() + "DG|AڳݤfC\n");
	return 0;
    }

    do_chat( name() + "DRMнۡT\n");
    return 1;
}

void accept_kill(object ob)
{
    do_chat( name() + "DR" + rank("self") + "Po" + ob->rank("respectful")
        + "nL޵LaS ...S\n");
}

void accept_negotiation(object who, string key)
{
    switch(key) {
    case "peace":
        if( !is_killing(who) ) {
            do_chat( name() + "`§ADGnAnC\n");
            remove_enemy(who);
            who->remove_enemy(this_object());
        }
        else do_chat( name() + "DGoܤֻA餣OAKOڬI\n");
        return;
    case "mercy":
        if( is_killing(who) ) {
            do_chat( name() + "jADGJMpAѴNǤFAC\n");
            remove_killer(who);
            remove_enemy(who);
            who->remove_killer(this_object());
            who->remove_enemy(this_object());
	    // add by dragoon
	    if( who->query_class() == "fighter" )
                who->gain_score("martial fame", - who->query_level() * 10);
        }
    }
}
