/*  ask.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

inherit F_CLEAN_UP;

int help();

int main(object me, string arg)
{
    string targ, key;
    object target;

    if( !arg || arg=="" ) return notify_fail("ݤH\n");

    if( sscanf(arg, "%s about %s", targ, key)==2 ) {
        target = present(targ, environment(me));
        if( !target || !target->is_character() )
            return notify_fail("ǫSoӤHC\n");
                // add by dragoon
                if( objectp(target) && target->query("no_fight") )
                        return notify_fail("??\n");
        message_vision("$NV$nťu" + key + "vC\n", me, target);
        target->accept_inquiry(me, key);
        return 1;
    }
    else if( sscanf(arg, "%s for %s", targ, key)==2 )
    {
	target = present(targ, environment(me));
	if( !target || !target->is_character() )
	    return notify_fail("ǫSoӤHC\n");

	// add by dragoon
	if( objectp(target) && target->query("no_fight") )
	    return notify_fail("??\n");

	switch(key) {
	case "help":
	    message_vision("$N$njsG" + target->rank("respectful")
		+ "ϩRI\n", me, target);
            break;
	case "peace":
            if( !target->is_fighting(me) ) {
		write(target->name() + "MAèSC\n");
		return 1;
            }
            message_vision("$NV$n@ADGo"
		+ target->rank("respectful")
		+ "ZjAbUتAoApƼĬͦpH\n", me, target);
            break;
	case "mercy":
            if( target->is_killing(me) )
                message_vision("$NV$nˡAsDDG" + target->rank("respectful")
                    + "ǩRIpUA]FI\n", me, target);
            break;
	default:
	}
	target->accept_negotiation(me, key);
	return 1;
    }
    else
	return notify_fail("Х help ask ѦһC\n");
}

int help()
{
    write(@TEXT
O榡Gask <YH> about <r>
          ask <YH> for <Aؼ>

oӫOAM npc i@²檺ʡAβĤ@خ榡ɭԪܦV npc ť
YrAĤGخ榡hOM npc iAAثejh npc F
ѪAؼЦG

help     VDUC
peace    VA몺HnDMѡC
mercy    VbAĤHDǡC

TEXT
    );
    return 1;
}
