/*  alias.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

#include <command.h>

inherit F_CLEAN_UP;

void create() { seteuid(getuid()); }

int main(object me, string arg)
{
    int i;
    mapping alias;
    string verb, replace, *vrbs;
    object link;

    SECURED_COMMAND;

    if( !(link = me->link()) )
	return notify_fail("ASsuC\n");

    if( !arg ) {
	alias = link->query_all_alias();
	if( !sizeof(alias) ) {
	    write("AثeèS]w aliasC\n");
	    return 1;
        } else  {
	    write("Aثe]w alias R\n");
	    vrbs = keys(alias);
	    for(i=0; i<sizeof(vrbs); i++)
		printf("%-15s = %s\n", vrbs[i], alias[vrbs[i]]);
	    return 1;
	}
    }

    if( sscanf(arg, "%s %s", verb, replace)!=2 )
	link->set_alias(arg, 0);
    else if( verb=="alias" )
	return notify_fail("AN \"alias\" O]wLγ~C\n");
    else if( verb=="" )
	return notify_fail("An] aliasS\n");
    else
	link->set_alias(verb, replace);

    write("Ok.\n");
    return 1;
}

int help (object me)
{
    write(@HELP
O榡 : alias <]wO> <tδѤO>
 
ɨtΩҴѤOݭnJܪr, bϥή(רOg`Ψ쪺)
γ\|PıK, ɧA(p)YiΦ@O]wôN즳OC
 
d:
    'alias sc score' |H sc N score OC
    'alias' ᤣ[ѼƫhCXAҦNOC
    'alias sc' | sc oӴNOC (pGA])
 
䤤iH $1, $2, $3 .... ӨNĤ@BĤGBĤTӰѼơMάO $* N
ҦѼơMpR
    'alias pb put $1 in $2'

hCA(p)R
    pb bandage bag

N|NR
    put bandage in bag
    
HELP
    );
    return 1;
}
