// gammer.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("MѤӱC", ({ "blind gammer", "gammer", "__ID_GAMMER__" }) );
	set_attr("dex", 29);
	set_attr("con", 21);
	set_attr("cor", 22);
	set_attr("str", 19);
	set_race("human");
	set_class("thief");
	set_level(44);

	set_skill("staff", 40);
	set_skill("stealing", 70);
	set_skill("dodge", 90);
	set_skill("blade", 30);
	set_skill("sword", 30);
	set_skill("unarmed", 50);
	set_skill("dagger", 70);
	set_skill("secondhand dagger", 70);
	set_skill("killerhood", 60);
	set_skill("force", 90);
	set_skill("regular force", 100);
    map_skill("force", "regular force");

	advance_stat("gin", 270);
	advance_stat("kee", 180);
	advance_stat("sen", 90);

	set("gender", "female");
	set("age", 66);
	set("long",
		"@ӽMFѤӱCMyKMOoH@ؿˤPıC\n");

	set("chat_chance", 8);
	set("chat_msg", ({
		"MѤӱCaDR_SOAܡS\n",
		"MѤӱCۦզGbťC\n",
		(: random_move :)
	}) );

	set("chat_chance_combat", 10);
	set("chat_msg_combat", ({
		"MѤӱCsDR_TcHbۭtCCT֥XӰڡT\n",
		(: random_move :),
	}) );
	set_stat_notify("kee", 40);

	setup();
	carry_object("/obj/area/obj/cloth")->wear();
	carry_object(__DIR__"obj/cane")->wield();
	carry_object(__DIR__"obj/syndicator")->wield("secondhand dagger");
}

private void give_coin(object who)
{
	object ob;

	if( environment(who) != environment() ) return;
	ob = new(__DIR__"obj/coin");
	if( !ob->move(who) )
		ob->move(environment());
}

void relay_say(object ob, string arg)
{
	int tmp = ob->query_temp("try/fon");
	// communicate with arbao
	if( !userp(ob) ){
		if( ob->id("__ID_ARBAO__") ){
			this_object()->delete("chat_msg");	// stop chat_msg
			this_object()->delete("chat_chance");
			if( strsrch(arg,"ӦnF")>= 0 ) {
				do_chat((:command(
"say u~sڪ_, pOwWhEplFa."):));
				return;
			}
			if( strsrch(arg,"O")>= 0 ){
				do_chat(({
(:command("say LQp, iH, OLlnAݷݳF.
o˥LaP̪~@Į."):),
				}));
				call_out((:message_vision("MѤӱC, LF.\n",this_player()):),4);
				call_out((:destruct(this_object()):),6);
				return;
			}
		}
	}
	if( !tmp || tmp==0 ){
		if( arg=="" && ob->query_temp("thief_qualified") ) {
			command("giggle");
			command("pat " + ob->query("id"));
			if( (string)ob->query_class() != "commoner" ) return;
			ob->set_class("thief");
			tell_object(ob, "A@WsFC\n");
			ob->improve_skill("sneak", 20);
			ob->improve_skill("stealing", 20);
			do_chat(({
				"MѤӱCDGFAoӵAC",
				(: give_coin, ob :),
				"MѤӱCDGpGAQǥơAoF赹ݡC\n",
			}));
			return;
		}
		if( strsrch(arg, "_") >= 0 )
			do_chat((: command, "say _SA_b̡S" :));
		else switch(random(10)) {
			case 0: do_chat((: command, "shake" :));
			case 1: do_chat((: command, "?" :));
			case 2: do_chat((: command, "steal coin from " + ob->query("id") :));
		}
		return;
	}
	switch(tmp) {
		case 8:
			if( strsrch(arg,"h")>=0 ) {
				do_chat(({
"MѤӱC㤣iK, ܹD: u, u, u, ڤQťoөm.\n",
"MѤӱCۻy}F, Aťƻ򦺰, _, ƻ򤳪.\n",
"AQ]\\ѤӱC]kાDN.\n",
				}));
				ob->set_temp("try/fon",10);
			}
			break;
		case 16:
			if( strsrch(arg,"")>=0 ) {
				do_chat(({
"MѤӱCD: ڨbT~heQhFĪ`F, AݥLԣ?\n",
"MѤӱCS㤣𪺻D: LnOQhFĪˤF, ̥LѤUĤ@\\|
QH, oOhFĪr`.\n",
"ݤFb٬OM, ATôb, hFĪoƦʸ.\n"
				}));
				ob->set_temp("try/fon",18);
			}
			break;
		case 45:
			if( strsrch(arg,"p޽")>=0 ) {
				do_chat(({
"MѤӱCD: o..o.. n[SHo˥sڤF.. ݨӳouOYlgF.\n",
"AԲӪ].\n", 
"MѤӱCIuF@U.\n",
(:command("say pl, ѱCl@Ӧ, hiDmh, ѱCl|AhLM
F, r, LiOQoFd."):),
				}));
				ob->set_temp("try/fon",48);
			}
			break;
		default:        break;
	}
}

int accept_fight()
{
	do_chat((: command, "?" :));
	return notify_fail("MѤӱCAYL@ ...C\n");
}

void init()
{
    if( environment(this_object())->query("connect-p") ) {
	command("say fF, ӳܤf...\n");
        message_vision("$Nww^jC\n", this_object());
        this_object()->move("/d/snow/square");
        return;
    }
	// Dont call original init() to check autofight.
	if( !is_chatting() && this_player()->query_temp("try/fon")==43 ){
		do_chat(({
			"AFѤӱC, X}@.\n",
			"ѤӱCܹD: ƻ}, .\n",
		}));
	}
}

private void ask_join(object player)
{
	if( !player || environment(player)!=environment() ) return;

	if( player->query_class() != "commoner" )
		command("say  ... HѤFMsHޤl``ᱼC\n");
	else {
		command("whisper " + player->query("id") + 
			" nåMMAhFSQpOOSsnuvڴNAJo ...");
		player->set_temp("thief_qualified", 1);
	}
}

int accept_object(object player, object ob)
{
	if( player->query_temp("try/fon")!=43 ){
		if( !ob->id("annatto comb") ) return 0;
		command("say xSo ... oO ... ڪޤlT");
		do_chat((: ask_join, player :));
		return 1;
	}
	if( ob->id("__ID_CHALLIE__") )	{
		do_chat(({
			"MѤӱCD: AoOۧڲMݤ, QFڶ?\n",
			"AQѤӱCʺ, ]\\iHϦo۫H}.\n"
		}));
		player->set_temp("try/fon", 45);
		return 1;
	}
}
