/*  poison.c

    Copyright (C) 1994-2000 Annihilator <annihilator@muds.net>

    This program is a part of ES2 mudlib. Permission is granted to use,
    modify, copy or distribute this program provided this copyright notice
    remains intact and subject to the restriction that this program MAY
    NOT be used in any way for monetary gain.

    Details of terms and conditions is available in the Copyright.ES2 file.
    If you don't receive this file along with this program, write to the
    primary author of ES2 mudlib: Annihilator <annihilator@muds.net>
*/

inherit CONDITION;

private void create()
{
    seteuid(getuid());
    DAEMON_D->register_condition_daemon("poison");
}

/*
    oӤrgO@ʪAΪgөwqrʽAH|NHiHE_
    XrʽA}ĸѬrC

    @ӨAiHۥѩwqrݩʡAHUuѰѦҡG

     - qrACo@|l˯AȡC
     - 줧rAorHʷ|CC
     - ʤrACo@|l˺몺AȡC
     - ʤrACo@|lˮ𪺪AȡC
    g - γDrAorHMO|CC

    @جrq`Ѥ椤TةʽcApڭ̩wqYسDrO[g 10,  10]A
    ĪvoسDrNݭnΫggMզXӹIA]ݭn@ةʽ謰[ 10,
    g 10]Ī~ѬrC

    rgt~iHwqXӰѼơG

    duration	- ɶACo@@N@A 0 rʴNC
    damage	- rʵo@ҦͩRIơC
		  ˮ`OOb update_condition @ΡAݺCʶˮ`C
*/

void
condition_update(object me, string cnd, mixed cnd_data)
{
    // u living ͩRA|rvTC
    if( me->query("life_form") != "living"
    ||	!mapp(cnd_data)
    ||	(cnd_data["duration"]--) < 1 ) {
	me->delete_condition(cnd);
	return;
    }

    if( cnd_data["damage"] )
    {
	int dam = cnd_data["damage"];

	tell_object(me, "Aro@FC\n");

	dam -= random( me->query_temp("apply/resist_poison") );
	if( dam < 0 ) dam = 0;

	me->consume_stat("HP", dam);
	if( cnd_data[""] > 0 ) me->damage_stat("gin", cnd_data[""] );
	if( cnd_data[""] > 0 ) me->damage_stat("kee", cnd_data[""] );
        if( cnd_data[""] > 0 ) me->damage_stat("sen", cnd_data[""] );
    }
    me->set_condition("poison", cnd_data);
}
/*
void
condition_apply(object me, string cnd, mapping cnd_data)
{
    if( ! mapp(cnd_data) ) return;
    if( cnd_data["damage"] && cnd_data["g"] )
	me->add_temp("apply/str", - cnd_data["g"]);
    if( cnd_data["damage"] && cnd_data[""] )
	me->add_temp("apply/int", - cnd_data[""]);
}

void
condition_unapply(object me, string cnd, mapping cnd_data)
{
    if( ! mapp(cnd_data) ) return;
    if( cnd_data["damage"] && cnd_data["g"] )
	me->add_temp("apply/str", cnd_data["damage"]);
    if( cnd_data["damage"] && cnd_data[""] )
	me->add_temp("apply/int", cnd_data["damage"]);
}
*/

